poj1837——dp

POJ 1837  dp

Balance

Time Limit: 1000MS   Memory Limit: 30000K
Total Submissions: 11278   Accepted: 7017

Description

Gigel has a strange "balance" and he wants to poise it. Actually, the device is different from any other ordinary balance. 
It orders two arms of negligible weight and each arm‘s length is 15. Some hooks are attached to these arms and Gigel wants to hang up some weights from his collection of G weights (1 <= G <= 20) knowing that these weights have distinct values in the range 1..25. Gigel may droop any weight of any hook but he is forced to use all the weights. 
Finally, Gigel managed to balance the device using the experience he gained at the National Olympiad in Informatics. Now he would like to know in how many ways the device can be balanced.

Knowing the repartition of the hooks and the set of the weights write a program that calculates the number of possibilities to balance the device. 
It is guaranteed that will exist at least one solution for each test case at the evaluation.

Input

The input has the following structure: 
• the first line contains the number C (2 <= C <= 20) and the number G (2 <= G <= 20); 
• the next line contains C integer numbers (these numbers are also distinct and sorted in ascending order) in the range -15..15 representing the repartition of the hooks; each number represents the position relative to the center of the balance on the X axis (when no weights are attached the device is balanced and lined up to the X axis; the absolute value of the distances represents the distance between the hook and the balance center and the sign of the numbers determines the arm of the balance to which the hook is attached: ‘-‘ for the left arm and ‘+‘ for the right arm); 
• on the next line there are G natural, distinct and sorted in ascending order numbers in the range 1..25 representing the weights‘ values.

Output

The output contains the number M representing the number of possibilities to poise the balance.

Sample Input

2 4
-2 3
3 4 5 8

Sample Output

2题意:在天平挂上所有的砝码,问使天平平衡的方案总数思路:dp,首先定义平衡度:平衡时为0,倾向左为正,右为负,设挂完第i个砝码时平衡度为j的方案数为dp(i,j),则dp(i,j)=dp(i-1,j-w[i]*x[1])+dp(i-1,j-w[i]*x[2])+...+dp(i-1,j-w[i]*x[C]);边界限定:dp(0,0)=1; dp(0,j)=0 (j!=0)所求解: dp(G,0)

记忆化搜索:

//47ms
#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;

const int maxn=30;
const int INF=15010;
int C,G;//C means the sum of hooks, G means the sum of weights
int x[maxn],w[maxn];
int d[maxn][INF];
int zero=INF/2;

int dp(int i,int j)
{
    int &ans=d[i][j];
    if(ans!=-1) return ans;
    if(i==0){
        if(j==zero) return ans=1;
        return ans=0;
    }
    int sum=0;
    for(int k=1;k<=C;k++) sum+=dp(i-1,j-w[i]*x[k]);
    return ans=sum;
}

int main()
{
    while(cin>>C>>G){
        for(int i=1;i<=C;i++) cin>>x[i];
        for(int i=1;i<=G;i++) cin>>w[i];
        memset(d,-1,sizeof(d));
        cout<<dp(G,zero)<<endl;
    }
    return 0;
}

记忆化搜索

递推:

//110ms
#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;

const int maxn=30;
const int INF=15010;
const int zero=INF/2;

int C,G;
int w[maxn],x[maxn];
int dp[maxn][INF];

int main()
{
    cin>>C>>G;
    for(int i=1;i<=C;i++) cin>>x[i];
    for(int i=1;i<=G;i++) cin>>w[i];
    memset(dp,0,sizeof(dp));
    for(int i=0;i<INF;i++) dp[0][i]=0;
    dp[0][zero]=1;
    for(int i=1;i<=G;i++){
        for(int j=0;j<INF;j++){
            for(int k=1;k<=C;k++){
                dp[i][j]+=dp[i-1][j-w[i]*x[k]];
            }
        }
    }
    cout<<dp[G][zero]<<endl;
    return 0;
}

递推

时间: 2024-10-28 22:15:11

poj1837——dp的相关文章

poj1837 dp

1 //Accepted 2176 KB 47 ms 2 //杠杆平横的条件:sum(c[i]*sum(g[j]))=0 3 // 所有的hook到原点的距离乘它上面挂着的物体的重量和的和为0 4 //对于一个hook,它到原点距离与所挂重量的乘积能达到的最大和值为15*25*20 5 //设dp[i][j]为前i个hook挂上物品后达到的sum为j的方案数 6 //则dp[i][j]+=dp[i-1][j-c[i]*g[j]](1<=j<=n) 7 //前i个hook能达到j由前i-1个ho

POJ-1837 Balance (DP背包问题)

Balance Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 13395   Accepted: 8382 Description Gigel has a strange "balance" and he wants to poise it. Actually, the device is different from any other ordinary balance. It orders two arms

DP总结 ——QPH

常见优化 单调队列 形式 dp[i]=min{f(k)} dp[i]=max{f(k)} 要求 f(k)是关于k的函数 k的范围和i有关 转移方法 维护一个单调递增(减)的队列,可以在两头弹出元素,一头压入元素. 队列中维护的是两个值.一个是位置,这和k的范围有关系,另外一个是f(k)的值,这个用来维护单调性,当然如果f(k)的值可以利用dp值在O(1)的时间内计算出来的话队列中可以只维护一个表示位置的变量. 枚举到一个i的时候,首先判断队首元素的位置是否已经不满足k的范围了,如果不满足就将队首

POJ1717 Dominoes DP,背包的变形

这道题目比较短,而且有图片很容易懂题意,就是每一张牌,分为上下两部分,上面有几个点,代表上部分为几,下面同样,然后n张牌平行竖直放置,这样每一张牌的上面部分组成第一行,下面部分组成第二行,上下两行的和是有差异的值为gap,每一张牌可以上下反一下,这样可以是的差异值gap缩小,问你使得gap值最小 需要翻牌的最少次数 首先这道题目跟POJ1837有点类似,但是 边界设置这道题明显会麻烦许多,因为之前做过了POJ1837,所以这道题一上来就选择了那个方法,但是a,b值的差异极端为6000,又有负的,

POJ1837 Balance[分组背包]

Balance Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 13717   Accepted: 8616 Description Gigel has a strange "balance" and he wants to poise it. Actually, the device is different from any other ordinary balance. It orders two arms

POJ 1745:Divisibility 枚举某一状态的DP

Divisibility Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 11001   Accepted: 3933 Description Consider an arbitrary sequence of integers. One can place + or - operators between integers in the sequence, thus deriving different arithmet

POJ1837:Balance(01背包)

Description Gigel has a strange "balance" and he wants to poise it. Actually, the device is different from any other ordinary balance. It orders two arms of negligible weight and each arm's length is 15. Some hooks are attached to these arms and

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往